import 'package:domain/generated/json/base/json_convert_content.dart';
import 'package:domain/entity/response/revise_log_s_g_entity.dart';

ReviseLogSGEntity $ReviseLogSGEntityFromJson(Map<String, dynamic> json) {
  final ReviseLogSGEntity reviseLogSGEntity = ReviseLogSGEntity();
  final List<ReviseLogSGRecords>? records = (json['records'] as List<dynamic>?)?.map(
          (e) => jsonConvert.convert<ReviseLogSGRecords>(e) as ReviseLogSGRecords).toList();
  if (records != null) {
    reviseLogSGEntity.records = records;
  }
  return reviseLogSGEntity;
}

Map<String, dynamic> $ReviseLogSGEntityToJson(ReviseLogSGEntity entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['records'] = entity.records.map((v) => v.toJson()).toList();
  return data;
}

extension ReviseLogSGEntityExtension on ReviseLogSGEntity {
  ReviseLogSGEntity copyWith({
    List<ReviseLogSGRecords>? records,
  }) {
    return ReviseLogSGEntity()
      ..records = records ?? this.records;
  }
}

ReviseLogSGRecords $ReviseLogSGRecordsFromJson(Map<String, dynamic> json) {
  final ReviseLogSGRecords reviseLogSGRecords = ReviseLogSGRecords();
  final String? id = jsonConvert.convert<String>(json['id']);
  if (id != null) {
    reviseLogSGRecords.id = id;
  }
  final String? operationName = jsonConvert.convert<String>(json['operation_name']);
  if (operationName != null) {
    reviseLogSGRecords.operationName = operationName;
  }
  final int? dataType = jsonConvert.convert<int>(json['data_type']);
  if (dataType != null) {
    reviseLogSGRecords.dataType = dataType;
  }
  final String? desc = jsonConvert.convert<String>(json['desc']);
  if (desc != null) {
    reviseLogSGRecords.desc = desc;
  }
  final ReviseLogSGRecordsContent? content = jsonConvert.convert<ReviseLogSGRecordsContent>(json['content']);
  if (content != null) {
    reviseLogSGRecords.content = content;
  }
  final String? createdAt = jsonConvert.convert<String>(json['created_at']);
  if (createdAt != null) {
    reviseLogSGRecords.createdAt = createdAt;
  }
  final String? actClass = jsonConvert.convert<String>(json['act_class']);
  if (actClass != null) {
    reviseLogSGRecords.actClass = actClass;
  }
  final String? actText = jsonConvert.convert<String>(json['act_text']);
  if (actText != null) {
    reviseLogSGRecords.actText = actText;
  }
  return reviseLogSGRecords;
}

Map<String, dynamic> $ReviseLogSGRecordsToJson(ReviseLogSGRecords entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['id'] = entity.id;
  data['operation_name'] = entity.operationName;
  data['data_type'] = entity.dataType;
  data['desc'] = entity.desc;
  data['content'] = entity.content?.toJson();
  data['created_at'] = entity.createdAt;
  data['act_class'] = entity.actClass;
  data['act_text'] = entity.actText;
  return data;
}

extension ReviseLogSGRecordsExtension on ReviseLogSGRecords {
  ReviseLogSGRecords copyWith({
    String? id,
    String? operationName,
    int? dataType,
    String? desc,
    ReviseLogSGRecordsContent? content,
    String? createdAt,
    String? actClass,
    String? actText,
  }) {
    return ReviseLogSGRecords()
      ..id = id ?? this.id
      ..operationName = operationName ?? this.operationName
      ..dataType = dataType ?? this.dataType
      ..desc = desc ?? this.desc
      ..content = content ?? this.content
      ..createdAt = createdAt ?? this.createdAt
      ..actClass = actClass ?? this.actClass
      ..actText = actText ?? this.actText;
  }
}

ReviseLogSGRecordsContent $ReviseLogSGRecordsContentFromJson(Map<String, dynamic> json) {
  final ReviseLogSGRecordsContent reviseLogSGRecordsContent = ReviseLogSGRecordsContent();
  final ReviseLogSGRecordsContentReviseHours? reviseHours = jsonConvert.convert<ReviseLogSGRecordsContentReviseHours>(json['revise_hours']);
  if (reviseHours != null) {
    reviseLogSGRecordsContent.reviseHours = reviseHours;
  }
  final ReviseLogSGRecordsContentReviseMsg? reviseMsg = jsonConvert.convert<ReviseLogSGRecordsContentReviseMsg>(json['revise_msg']);
  if (reviseMsg != null) {
    reviseLogSGRecordsContent.reviseMsg = reviseMsg;
  }
  return reviseLogSGRecordsContent;
}

Map<String, dynamic> $ReviseLogSGRecordsContentToJson(ReviseLogSGRecordsContent entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['revise_hours'] = entity.reviseHours?.toJson();
  data['revise_msg'] = entity.reviseMsg?.toJson();
  return data;
}

extension ReviseLogSGRecordsContentExtension on ReviseLogSGRecordsContent {
  ReviseLogSGRecordsContent copyWith({
    ReviseLogSGRecordsContentReviseHours? reviseHours,
    ReviseLogSGRecordsContentReviseMsg? reviseMsg,
  }) {
    return ReviseLogSGRecordsContent()
      ..reviseHours = reviseHours ?? this.reviseHours
      ..reviseMsg = reviseMsg ?? this.reviseMsg;
  }
}

ReviseLogSGRecordsContentReviseHours $ReviseLogSGRecordsContentReviseHoursFromJson(Map<String, dynamic> json) {
  final ReviseLogSGRecordsContentReviseHours reviseLogSGRecordsContentReviseHours = ReviseLogSGRecordsContentReviseHours();
  final String? field = jsonConvert.convert<String>(json['field']);
  if (field != null) {
    reviseLogSGRecordsContentReviseHours.field = field;
  }
  final int? value = jsonConvert.convert<int>(json['value']);
  if (value != null) {
    reviseLogSGRecordsContentReviseHours.value = value;
  }
  return reviseLogSGRecordsContentReviseHours;
}

Map<String, dynamic> $ReviseLogSGRecordsContentReviseHoursToJson(ReviseLogSGRecordsContentReviseHours entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['field'] = entity.field;
  data['value'] = entity.value;
  return data;
}

extension ReviseLogSGRecordsContentReviseHoursExtension on ReviseLogSGRecordsContentReviseHours {
  ReviseLogSGRecordsContentReviseHours copyWith({
    String? field,
    int? value,
  }) {
    return ReviseLogSGRecordsContentReviseHours()
      ..field = field ?? this.field
      ..value = value ?? this.value;
  }
}

ReviseLogSGRecordsContentReviseMsg $ReviseLogSGRecordsContentReviseMsgFromJson(Map<String, dynamic> json) {
  final ReviseLogSGRecordsContentReviseMsg reviseLogSGRecordsContentReviseMsg = ReviseLogSGRecordsContentReviseMsg();
  final String? field = jsonConvert.convert<String>(json['field']);
  if (field != null) {
    reviseLogSGRecordsContentReviseMsg.field = field;
  }
  final String? value = jsonConvert.convert<String>(json['value']);
  if (value != null) {
    reviseLogSGRecordsContentReviseMsg.value = value;
  }
  return reviseLogSGRecordsContentReviseMsg;
}

Map<String, dynamic> $ReviseLogSGRecordsContentReviseMsgToJson(ReviseLogSGRecordsContentReviseMsg entity) {
  final Map<String, dynamic> data = <String, dynamic>{};
  data['field'] = entity.field;
  data['value'] = entity.value;
  return data;
}

extension ReviseLogSGRecordsContentReviseMsgExtension on ReviseLogSGRecordsContentReviseMsg {
  ReviseLogSGRecordsContentReviseMsg copyWith({
    String? field,
    String? value,
  }) {
    return ReviseLogSGRecordsContentReviseMsg()
      ..field = field ?? this.field
      ..value = value ?? this.value;
  }
}